package com.example.demo.messages.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

import com.example.demo.messages.model.MessageEntity;

// Хранилище для сущности "Сообщение"
public interface MessageRepository extends CrudRepository<MessageEntity, Long>, PagingAndSortingRepository<MessageEntity, Long> {
    // Получить сообщение по пользователю и идентификатору
    Optional<MessageEntity> findOnyByUserIdAndId(Long userId, Long id);
    
    // Получить список всех сообщений (с пагинацией)
    Page<MessageEntity> findAll(Pageable pageable);
    
    // Получить список сообщений по пользователю
    List<MessageEntity> findByUserId(Long userId);

    // Получить список сообщений по пользователю (с пагинацией)
    Page<MessageEntity> findByUserId(Long userId, Pageable pageable);
}
