package com.example.demo.users.api;

import java.util.Objects;

import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotNull;

// DTO для корзины покупок пользователя
public class UserCartDto {
    // Идентификатор типа товара
    @NotNull
    private Long type;

    // Название типа товара
    private String typeName;

    // Цена товара
    @NotNull
    @Min(1000)
    private Double price;

    // Количество товаров
    @NotNull
    @Min(1)
    private Integer count;

    // Получить идентификатор типа товара
    public Long getType() {
        return type;
    }

    // Установить идентификатор типа товара
    public void setType(Long typeId) {
        this.type = typeId;
    }

    // Получить название типа товара
    public String getTypeName() {
        return typeName;
    }

    // Установить название типа товара
    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    // Получить цену товара
    public Double getPrice() {
        return price;
    }

    // Установить цену товара
    public void setPrice(Double price) {
        this.price = price;
    }

    // Получить количество товаров
    public Integer getCount() {
        return count;
    }

    // Устаовить количество товаров
    public void setCount(Integer count) {
        this.count = count;
    }

    // Получить хэш-код объекта
    @Override
    public int hashCode() {
        return Objects.hash(type, price);
    }

    // Сравнить объекты
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        UserCartDto other = (UserCartDto) obj;
        return Objects.equals(type, other.type)
                && Objects.equals(price, other.price);
    }
}
